<template>
        <SpinnerHolder v-if="loading" style="background-color: #000000"></SpinnerHolder>
        <Background v-else-if="!loading && foundRestaurant && delivery && active" class="container" :custom="false">
            <div v-if="!modalForm">
                <Modal v-if="!openRestaurant" @close="hideForm()">
                    <div class="send-form">
                        <div class="form-group">
                            <img class="logoc" src="../assets/icons/redclock.png"/>
                            <span class="label" style="color: red; font-weight: bold;">{{ $t('deliverystatusMessage') }}</span>
                        </div>
                        <div class="form-group">
                            <span>{{ $t('scheduleMessage') }}: 
                                <span style="font-weight: bold">{{scheduleInitDay}} - {{scheduleEndDay}}</span>
                            </span>
                        </div>
                        <!-- <div class="form-group">
                            <AjaxButton
                                    class="final-button"
                                    :loading="loading"
                                    :text="$t('showMenu')"
                                    @click="gotoMenu()"
                                    style="color: white; background-color: #feca38; font-weight: bold; font-size: 18px;"
                            ></AjaxButton>
                            <span v-if="ajaxError" class="error">{{ $t('ajaxError') }}</span>
                        </div> -->
                    </div>
                </Modal>
            </div>
            <HomeButton class="homebutton"></HomeButton>

            <CardLayout>
                <template slot="top">
                    <div class="home-top" :style="style">
                        <div class="mask"></div>´
                            <Background class="fondoimg" :custom="true">
                                <VariableLogo class="logo" :custom="true" ></VariableLogo>
                            </Background>
                        <h3 class="name-restaurant" v-text="nameRestaurant"></h3>
                    </div>
                </template>
                <template slot="body">
                    <div class="home-body">
                        <div v-if="languajeSelector" style="display: contents;">
                            <LanguageSelector class="language-selector" @select="languageSelected"></LanguageSelector>
                        </div>
                    
                        <div class="info-restaurant">
                            <p class="contenido">{{descriptionDelivery}}</p>
                            <p class="titulo">{{$t('address')}}:<span class="contenido"> {{address}}</span></p>

                            <div><b class="titulo">{{$t('scheduleService')}}: </b>
                                <p class="contenido">{{$t('sunday')}}:
                                <span v-if="domingoClose">
                                    {{schedule.DOMINGO.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.DOMINGO.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                                <p class="contenido">{{$t('monday')}}:
                                <span v-if="lunesClose">
                                    {{schedule.LUNES.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.LUNES.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                                <p class="contenido">{{$t('tuesday')}}:
                                <span v-if="martesClose">
                                    {{schedule.MARTES.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.MARTES.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                                <p class="contenido">{{$t('wednesday')}}:
                                <span v-if="miercolesClose">
                                    {{schedule.MIERCOLES.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.MIERCOLES.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                                <p class="contenido">{{$t('thursday')}}:
                                <span v-if="juevesClose">
                                    {{schedule.JUEVES.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.JUEVES.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                                <p class="contenido">{{$t('friday')}}:
                                <span v-if="viernesClose">
                                    {{schedule.VIERNES.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.VIERNES.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                                <p class="contenido">{{$t('saturday')}}:
                                <span v-if="sabadoClose">
                                    {{schedule.SABADO.initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}-
                                    {{schedule.SABADO.endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })}}
                                </span>
                                <span class="span-close" v-else >{{$t('close')}}</span>
                                </p>
                            </div>

                        <p class="titulo">{{$t('telephone')}}: <span class="contenido">{{phone}}</span></p>
                        </div>
                        <div class="redes">
                            <div v-show="facebook != ''">
                                <a v-bind:href=facebook target="_blank"><img class="logos facebook" src="../assets/icons/facebook.svg"/></a>
                            </div>
                            <div v-show="instagram != ''">
                                <a v-bind:href="instagram" target="_blank"> <img class="logos instagram" src="../assets/icons/instagram.svg"/></a>
                            </div>
                        </div>
                        <div v-on:click="addViewsShipping()" v-if="activeBtn" v-show="shipping">
                            <button block class="boton-servicio"><h3>{{$t('delivery')}}</h3></button>
                        </div>
                        <div v-on:click="addViewsCollect()" v-if="activeBtn" v-show="collect">
                            <button class="boton-recoger"><h3>{{$t('pickUp')}}</h3></button>
                        </div>
                    </div>
                </template>
            </CardLayout>
        </Background>
        <div v-else-if="!active" class="inactive-service"></div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import Background from '@/components/Background.vue'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import VariableLogo from '@/components/VariableLogo.vue'
import MenuService from "../services/MenuService"
import CardLayout from "@/layouts/CardLayout.vue"
import Modal from "@/components/Modal.vue"
import AjaxButton from "@/components/AjaxButton.vue"
import Localization from '@/models/Localization'
import LanguageSelector from '@/components/LanguageSelector.vue'
import { MainView, TypeOrder } from '@/store/state'
import { DeliveryMenu, Schedule} from "@/models/DeliveryMenu";
import Menu, { TypeView } from "@/models/Menu";
import {localizedDeliveryDescription} from "@/utils/LocalizationsUtils";
import {isOpen, getDayOfWeek} from "@/utils/ScheduleUtils";
import LocalizedText from "@/models/LocalizedText";
import HomeButton from "@/components/HomeButton.vue";


@Component({
    components: {
        Background,
		VariableLogo,
        SpinnerHolder,
        CardLayout,
        Modal,
        AjaxButton,
        LanguageSelector,
        HomeButton
    }
})
export default class InfoRestaurant extends Vue {
    activeBtn = true;
    loading = true
    foundRestaurant = false
    nameRestaurant = ''
    address = ''
    delivery = false
    imageDeliveryURL = ''
    phone = ''
    openRestaurant = false
    schedule: Schedule | undefined = undefined;
    scheduleInitDay ='';
    scheduleEndDay ='';
    shipping = false
    collect = false
    facebook = ''
    instagram = ''
    url = ''
    ajaxError = false
    modalForm = false
    active = true
    languajeSelector = false
    descriptionDelivery = ""
    domingoClose = false
    lunesClose = false
    martesClose = false
    miercolesClose = false
    juevesClose = false
    viernesClose = false
    sabadoClose = false
    viewByQr = false

    async created() {
        this.viewByQr = false
        const restaurantId = this.$route.params.restaurantId
        const menuId = this.$route.params.menuId

        await this.$store.dispatch('getRestaurant', restaurantId)
        if(!this.$store.state.restaurant){
            await this.notFound()
            return
        }

        await this.$store.dispatch('getMenu', menuId)
        if(!this.$store.state.menu) {
            await this.notFound()
            return
        }
        await this.$store.dispatch('getDeliveryMenu', this.$store.state.menu.id);

        const result = MenuService.getSocialNetworkFromMenu(this.$store.state.menu.id)
        result.then(res => {
            if(res != null){
                if(res.facebook != null) this.facebook = res.facebook
                if(res.instagram != null) this.instagram = res.instagram
            }
        })
        await this.$store.dispatch('setNewOrder')
        await this.showInfoRestaurantDelivery()

        if(this.$route.query.origin == 'qr'){
            this.viewByQr = true
            await MenuService.addView(this.$store.state.menu.id, TypeView.QR)
        }

        if(this.$store.state.mainView == MainView.DIRECTORY && this.delivery){
            this.$router.push('/menu')
            await MenuService.addView(this.$store.state.menu.id, TypeView.SHIPPING)
        }
    }

    async gotoMenu(){
        await this.$store.dispatch('setTypeOrder', TypeOrder.LOCAL)
        await this.$router.push('/menu')
    }

    async notFound() {
        this.foundRestaurant = false
        this.loading = false
    }

    async showInfoRestaurantDelivery(){
        const menu: Menu | undefined = this.$store.state.menu;
        const delivery: DeliveryMenu | undefined = this.$store.state.deliveryMenu;
        if(menu){
            this.foundRestaurant = true
            this.nameRestaurant = menu.name
            this.active = menu.active

            const localizations = menu.localizations

            this.loading = true 
            this.openRestaurant = await isOpen(menu.id)
            this.loading = false

            if (localizations && localizations.length == 1 && this.active) {
                this.setLocalization(localizations[0])
            }
            else {
                this.languajeSelector = true;
                const local = localizations.find(local => local.language == 'spanish')
                if (local) this.setLocalization(local)
            }
        }

        if (delivery){
            const now = new Date();
            const dayOfWeek = getDayOfWeek(now.getDay());
            this.delivery = delivery.active
            this.address = delivery.address
            this.descriptionDelivery = localizedDeliveryDescription(delivery);
            this.imageDeliveryURL = delivery.imageDeliveryURL
            this.phone = delivery.phones?.localPhone?.phone || '';

            if(delivery.schedule){
                this.schedule = delivery.schedule;
                this.getOpenDays(this.schedule)
                this.scheduleInitDay = delivery.schedule[dayOfWeek].initHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
                this.scheduleEndDay = delivery.schedule[dayOfWeek].endHour.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
            }

            this.shipping = delivery.shipping;
            this.collect = delivery.collect;
        }
    }

    setLocalization(localization: Localization){
        this.$store.dispatch('changeCurrency', localization.currency)
        this.$store.dispatch('changeLanguage', localization.language)
        this.$emit('select')
        this.languageSelected()
    }

    languageSelected() {
        const lang: string = this.$store.state.language
        this.$store.state.deliveryMenu.descriptionDelivery.forEach(async (docDescriptionDelivery: LocalizedText) => {
            if(docDescriptionDelivery.language == lang.toUpperCase() || docDescriptionDelivery.language == lang){
                this.descriptionDelivery = docDescriptionDelivery.text
            }
        });
    }

    async addViewsShipping(){
        if(!this.viewByQr){
            await MenuService.addView(this.$store.state.menu.id, TypeView.SHIPPING)
        }
        await this.$store.dispatch('setTypeOrder', TypeOrder.DELIVERY)
        await this.$router.push('/menu')
    }

    async addViewsCollect(){
        if(!this.viewByQr){
            await MenuService.addView(this.$store.state.menu.id, TypeView.COLLECT)
        }   
        await this.$store.dispatch('setTypeOrder', TypeOrder.COLLECT)
        await this.$router.push('/menu')
    }

    get style() {
        return `background-image: url('${this.imageDeliveryURL}')`;
    }

    hideForm() {
        this.modalForm = true;
        const active = this.$store.state.deliveryMenu.shipping;
        if(active === false || !this.openRestaurant ) {
            return this.activeBtn = false;
        }
    }

    getOpenDays(schedule: Schedule){
        this.domingoClose = schedule.DOMINGO.open
        this.lunesClose = schedule.LUNES.open
        this.martesClose = schedule.MARTES.open
        this.miercolesClose = schedule.MIERCOLES.open
        this.juevesClose = schedule.JUEVES.open
        this.viernesClose = schedule.VIERNES.open
        this.sabadoClose = schedule.SABADO.open
    }
}
</script>

<style lang="scss" scoped>
.homebutton {
    position: fixed;
    z-index: 3000;
    right: 1vh;
    top: 1vh;
}
::v-deep .page-content {
    padding-top: 0;
}

.home-body{
    padding-top: 40px;
}

.page-head{
    display: none;
}

.redes{
    margin: 0 6.5px;
}

.logos{
    display: inline-flex;
    width: 29px;
    border-radius: 45%;
    margin: 15px;
    padding: 10px;
}

.facebook{
    background-color: #3B5998;
}

.instagram{
    background-color: #CD486B;
}

.titulo{
    font-family: 'Roboto condensed';
    font-weight: 700;
    line-height: 16px;
}
.contenido{
    font-family:  'Roboto condensed';
    font-weight: 400;
    color: #757070;
    margin: 0;
}

.logoc{
    width: 19px;
    margin-right: 5px;
}

a:link
{
    text-decoration:none;
}

.home-top {
    height: 100%;
    width: 100%;
    max-height: 150px;
    max-width: 100%;
    color: #000;
    display: flex;
    align-items: center;
    background-image: url("~@/assets/icons/bee-blanco.svg");
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center;
    .fondoimg, .logo{
    border-radius: 15px;
    }
    .fondoimg{
        z-index: 982;
        margin-top: 150px;
        width:86px;
        height :86px;
    }

    .logo{
    width:84px;
    height :84px;
    z-index: 992;
    display: flex;
    justify-content: flex-start;
    padding-left: 2%;
    }
}

.home-body {
    display: flex;
    flex-direction: column;
    justify-content: space-around;
    font-display: 'Roboto Condensed';
    .card-title {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin-bottom: 20px;
        padding: 0 20px;

        span {
            font-weight: bold;
        }

        .see-all {
            font-size: 11px;
        }
    }
}

.name-restaurant {
    padding: 0 5px;
    text-align: center;
    margin-top: 190px;
    font-weight: bold;
    line-height: 19px;
    z-index: 992;
}

.info-restaurant {
    padding: 10px 10px;
    text-align: justify;
}

.redes {
    justify-content: center;
    display: flex;
}

.boton-servicio {
    background: #FECA38;
    border: 1px solid #FECA38;
    box-sizing: border-box;
    border-radius: 6px;
    margin: 0 10px;
    color: white;
    width: 95%;
}

.boton-recoger{
    background: white;
    border: 1px solid #FECA38;
    box-sizing: border-box;
    border-radius: 6px;
    margin: 10px 10px;
    color: #faca33;
    width: 95%;
}

.send-form {
    color: black;
    font-family: "Roboto Condensed";
    .form-group {
        margin: 10px;
        text-align: center;
    }
}

.inactive-service{
	margin: 0;
	width: 100%;
	height: 100%;
	background-image: url("~@/assets/img/out-of-service.png");
	background-size: cover;
	background-repeat: no-repeat;
}

.language-selector{
    justify-content: center;
    padding-top: 3%;
    padding-bottom: 5%;
}

.label{
    justify-content: center;
    align-content: center;
}
</style>
